// ============================================================
// Project			:  Advanced Help
// Author 			:  Scriode
// Description		:  Compiles a list of every command
//						:  that can be used in a server.
//						:  v0.2
// ============================================================


$AdvHelp::List::Page0 = "\c6Type \c3/AdvHelp Page # \c6for different help pages or \c3/AdvHelp [command] \c6to get the list of parameters.";

package AdvHelp
{
	function gameConnection::autoAdminCheck(%a,%b,%c)
	{
		parent::autoAdminCheck(%a,%b,%c);
		if($AdvHelp::Loop) return;
		$AdvHelp::Loop = true;
		AdvHelpLoop();
	}
};
activatePackage(AdvHelp);

$AdvHelp::Loop::Delay = 5; //Minutes

function serverCmdAdvHelpStartLoop(%client) {
	if(!%client.player.isSuperAdmin) return;
	messageClient(%client, '', "You have started the Advanced Help Loop.");
	AdvHelpLoop();
}

function serverCmdAdvHelpStopLoop(%client) {
	if(!%client.player.isSuperAdmin) return;
	messageClient(%client, '', "You have stopped the Advanced Help Loop.");
	cancel($AdvHelpLoop);
}

function AdvHelpLoop()
{
	cancel($AdvHelpLoop);
	announce($AdvHelp::List::Page0);
	$AdvHelpLoop = schedule($AdvHelp::Loop::Delay * 60000, 0, AdvHelpLoop);
}

function ServerCmdAdvHelp(%client, %command, %num) {
	if(!$AdvHelp::Created)
		CreateHelpList();
	
	if((strlwr(%command) $= "page" || strlwr(%command) $= "p") && %num > $AdvHelp::CurPage) {
		%text = "\c3That page doesn't exist.";
		%text2 = $AdvHelp::List::Page0;
	}
	else if(%command $= "" && %num == 0) {
		%text = $AdvHelp::List::Page0;
		%text2 = "\c4Page " @ "0/" @ $AdvHelp::CurPage;
	}
	else if((strlwr(%command) $= "page" || strlwr(%command) $= "p")  && %temp <= $AdvHelp::CurPage) {
		%text = $AdvHelp::List::Page[%num];
		%text2 = $AdvHelp::List::Page0;
		%text3 = "\c4Pages " @ %num @ "/" @ $AdvHelp::CurPage;
	}
	else {
		for(%i = 0; %i < $AdvHelp::CommandNum; %i++) {
			if(strlwr(%command) == strlwr($AdvHelp::Command[%i]) && $AdvHelp::CommandHelp::Slash[%command] !$= "") {
				%text = "\c6We've retrieved as much info as we can from \c3" @ %command @ "\c6.";
				%text2 = "\c6Here are the parameters it takes. \c3" @ $AdvHelp::CommandHelp::Slash[%command];
				%text3 = $AdvHelp::List::Page0;
			}
			else if(!$AdvHelp::CommandHelp::Slash[%command]) {
				%text = "\c3" @ %command SPC "\c6has no parameters.";
				%text2 = $AdvHelp::List::Page0;
				%text3 = "";
			}
			else {
				%text = "\c3" @ %command SPC "\c6is not a valid command.";
				%text2 = $AdvHelp::List::Page0;
				%text3 = "";
			}
		}
	}
		
	if(%text !$= "") messageClient(%client, '', %text);
	if(%text2 !$= "") messageClient(%client, '', %text2);
	if(%text3 !$= "") messageClient(%client, '', %text3);
}

$AdvHelp::FileTypeLength = 3;

function ClearAdvHelp() {
	for(%i = 1; %i <= $AdvHelp::CurPage; %i++)
		$AdvHelp::List::Page[%i] = "";
	$AdvHelp::CurPage = 0;
	$AdvHelp::Created = 0;
}

function CreateHelpList() {
	for(%i = 1; %i <= $AdvHelp::CurPage; %i++)
		$AdvHelp::List::Page[%i] = "";
	$AdvHelp::CurPage = 0;
	$AdvHelp::Created = true;
	
	%p="Add-Ons/*_*";
	for(%f=findFirstFile(%p);%f!$="";%f=findNextFile(%p))
		if(getSubStr(%f, strlen(%f)-$AdvHelp::FileTypeLength, $AdvHelp::FileTypeLength) $= ".cs" && $AddOn__[GetAddonName(%f)] == 1)
			FindServerCmd(%f);
}

$AdvHelp::FunctionCharCount = 18;

function FindServerCmd(%loc) {
	if(!isFile(%loc)) {
		echo("AdvHelp: Error, this shouldn't have happened");
        return;
    }
    %file = new FileObject();
    %file.openForRead(%loc);
    while(!%file.isEOF()) {
        %line = %file.readLine();
        if(strlwr(getSubStr(%line, $AdvHelp::FunctionCharCount/2, $AdvHelp::FunctionCharCount/2)) $= "servercmd") {
			%tempNum = 0;
			for(%i = $AdvHelp::FunctionCharCount; %i < strlen(%line); %i++) {
				if(getSubStr(%line, %i, 1) $= "(") {
					%tempNum = %i - $AdvHelp::FunctionCharCount;
					break;
				}
			}
			
			%tempNum2 = 0;
			for(%i = $AdvHelp::FunctionCharCount + %tempNum; %i < strlen(%line); %i++) {
				if(getSubStr(%line, %i, 1) $= ")") {
					%tempNum2 = %i-1;
					break;
				}
			}
			
			AddItemToList(	getSubStr(%line, $AdvHelp::FunctionCharCount, %tempNum), 
							strreplace(strreplace(strreplace(getSubStr(%line, $AdvHelp::FunctionCharCount + %tempNum + 1, %tempNum2), "%", ""), "client", ""),")",""));
		}
    }
    %file.close();
    %file.delete();
}

$AdvHelp::MaxCommandsPerPage = 10;

function AddItemToList(%text, %args) {
	if(%text $= "") return;
	for(%i = 0; %i < $AdvHelp::CommandNum; %i++)
		if(%text $= $AdvHelp::Command[%i]) return;	
	if($AdvHelp::PageL++ % $AdvHelp::MaxCommandsPerPage == 0)
		$AdvHelp::CurPage++;
	if($AdvHelp::CurPage)
		$AdvHelp::List::Page[$AdvHelp::CurPage] = $AdvHelp::List::Page[$AdvHelp::CurPage] @ "\c6/" @ %text @ "\c3 - ";
		
	$AdvHelp::CommandHelp::Slash[%text] = %args;
	
	$AdvHelp::Command[$AdvHelp::CommandNum] = %text;
	$AdvHelp::CommandNum++;
}

$AdvHelp::AddonCharC = 8;

function GetAddonName(%loc) {
	%tempNum = 0;
	for(%i = 0; %i < strlen(%loc); %i++) {
		if(getSubStr(%loc, $AdvHelp::AddonCharC  + %i, 1) $= "/") {
			%tempNum = %i;
			break;
		}
	}
	return getSubStr(%loc, $AdvHelp::AddonCharC , %tempNum);
}

function AnalyzeCode(%args) { //This will be used to analyse the code for different details on the help 
	
}